/*
 * Copyright (C) 2015  Roman Pauer
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <stdint.h>

const static uint8_t hqTable2x_00[256] = { // table for upper left corner
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 15, 12, 5,  3, 17, 13,
  4, 4, 6, 18, 4, 4, 6, 18, 5,  3, 12, 12, 5,  3,  1, 12,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 17, 13, 5,  3, 16, 14,
  4, 4, 6, 18, 4, 4, 6, 18, 5,  3, 16, 12, 5,  3,  1, 14,
  4, 4, 6,  2, 4, 4, 6,  2, 5, 19, 12, 12, 5, 19, 16, 12,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 12, 5,  3, 16, 12,
  4, 4, 6,  2, 4, 4, 6,  2, 5, 19,  1, 12, 5, 19,  1, 14,
  4, 4, 6,  2, 4, 4, 6, 18, 5,  3, 16, 12, 5, 19,  1, 14,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 15, 12, 5,  3, 17, 13,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 12, 5,  3, 16, 12,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 17, 13, 5,  3, 16, 14,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 13, 5,  3,  1, 14,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 12, 5,  3, 16, 13,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 12, 5,  3,  1, 12,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3, 16, 12, 5,  3,  1, 14,
  4, 4, 6,  2, 4, 4, 6,  2, 5,  3,  1, 12, 5,  3,  1, 14,
};

const static uint8_t hqTable2x_01[256] = { // table for upper right corner
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4, 19, 19,
  6, 6, 15, 17,  2,  2, 12, 13, 6, 6, 12,  1, 2,  2, 12, 12,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3,  3,
  6, 6, 15, 17,  2,  2, 12, 13, 6, 6, 16, 16, 2,  2, 12, 12,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3,  3,
  6, 6, 12, 16, 18, 18, 12, 12, 6, 6, 16, 16, 2,  2, 12, 12,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3,  3,
  6, 6, 16, 16,  2,  2, 12, 13, 6, 6, 16,  1, 2,  2, 12, 12,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4, 19, 19,
  6, 6, 17, 16,  2,  2, 13, 14, 6, 6, 16,  1, 2,  2, 12, 14,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3,  3,
  6, 6, 17, 16,  2,  2, 13, 14, 6, 6, 16,  1, 2,  2, 13, 14,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3, 19,
  6, 6,  1,  1, 18, 18, 12, 14, 6, 6, 16,  1, 2, 18, 12, 14,
  4, 4,  5,  5,  4,  4,  3,  3, 4, 4,  5,  5, 4,  4,  3,  3,
  6, 6, 16,  1,  2,  2, 12, 14, 6, 6,  1,  1, 2,  2, 12, 14,
};

const static uint8_t hqTable2x_11[256] = { // table for lower right corner
   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
   5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
   5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,
   6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,
  15, 15, 12, 16, 17, 17,  1, 16, 12, 16, 16, 16, 16, 16, 16,  1,
   6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,
  17, 17, 16, 16, 16, 16,  1,  1,  1, 16, 16,  1,  1,  1,  1,  1,
   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
   3,  3, 19,  3,  3,  3, 19,  3,  3,  3,  3,  3,  3,  3,  3,  3,
   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
   3,  3, 19,  3,  3,  3, 19,  3,  3,  3,  3,  3,  3,  3, 19,  3,
   2,  2,  2,  2,  2,  2,  2,  2, 18,  2,  2,  2, 18,  2,  2,  2,
  12, 12, 12, 12, 13, 13, 12, 12, 12, 12, 12, 12, 12, 13, 12, 12,
   2,  2,  2,  2,  2,  2,  2,  2, 18,  2,  2,  2, 18,  2, 18,  2,
  13, 13, 12, 13, 14, 14, 14, 14, 12, 12, 12, 12, 14, 14, 14, 14,
};

const static uint8_t hqTable2x_10[256] = { // table for lower left corner
   4,  4, 4,  4, 4, 4, 4, 4,  6,  6,  6,  6,  6,  6,  6,  6,
   4,  4, 4,  4, 4, 4, 4, 4,  6,  6,  6,  6,  6,  6,  6,  6,
   4,  4, 4,  4, 4, 4, 4, 4,  2,  2, 18, 18,  2,  2,  2,  2,
   4,  4, 4,  4, 4, 4, 4, 4,  2,  2,  2,  2,  2,  2,  2,  2,
   5,  5, 5,  5, 5, 5, 5, 5, 15, 17, 12,  1, 15, 17, 16, 16,
   5,  5, 5,  5, 5, 5, 5, 5, 12, 16, 16, 16, 16, 16, 16,  1,
   3,  3, 3,  3, 3, 3, 3, 3, 12, 13, 12, 12, 12, 13, 12, 12,
  19, 19, 3,  3, 3, 3, 3, 3, 12, 12, 12, 12, 12, 13, 12, 12,
   4,  4, 4,  4, 4, 4, 4, 4,  6,  6,  6,  6,  6,  6,  6,  6,
   4,  4, 4,  4, 4, 4, 4, 4,  6,  6,  6,  6,  6,  6,  6,  6,
   4,  4, 4,  4, 4, 4, 4, 4,  2,  2, 18, 18,  2,  2,  2,  2,
   4,  4, 4,  4, 4, 4, 4, 4,  2,  2,  2, 18,  2,  2,  2,  2,
   5,  5, 5,  5, 5, 5, 5, 5, 17, 16, 16,  1, 17, 16, 16,  1,
   5,  5, 5,  5, 5, 5, 5, 5,  1,  1, 16,  1, 16,  1,  1,  1,
   3,  3, 3,  3, 3, 3, 3, 3, 13, 14, 12, 14, 13, 14, 13, 14,
  19, 19, 3, 19, 3, 3, 3, 3, 12, 14, 12, 14, 12, 14, 12, 14,
};

void hq2x_16_Init(uint32_t *hqTable) {
    int index;
    uint8_t *_hqTable8;

    _hqTable8 = (uint8_t *) hqTable;
    for (index = 0; index < 256; index++) {
        _hqTable8[4*index+0] = hqTable2x_00[index];
        _hqTable8[4*index+1] = hqTable2x_01[index];
        _hqTable8[4*index+2] = hqTable2x_11[index];
        _hqTable8[4*index+3] = hqTable2x_10[index];
    }
}

