/*
 * Copyright (C) 2015  Roman Pauer
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __HQX_COMMON_H_
#define __HQX_COMMON_H_

#include <stdint.h>

#define MAX_WIDTH 320


void prepare_yuv_palette_rgb_16(const uint16_t * restrict RGBpal, uint64_t * restrict RGBYUVpal);
void convert_yuv_8_rgb_16(const uint8_t * restrict src, uint32_t * restrict yuvdst, uint16_t * restrict rgbdst, const uint64_t * restrict RGBYUVpal, int width);
void convert_yuv_16(uint16_t * restrict src, uint32_t * restrict dst, int width);
void calculate_pattern(const uint32_t * restrict yuvsrc1, const uint32_t * restrict yuvsrc2, const uint32_t * restrict yuvsrc3, uint8_t * restrict dst, int width);

#endif

